Wecon PI Studio HMI Project Programmer TextContent Stack-based Buffer Overflow Remote Code Execution Vulnerability

2018-05-04T00:00:00
ID ZDI-18-409
Type zdi
Reporter Michael DePlante - Leahy Center for Digital Investigation at Champlain College
Modified 2018-06-22T00:00:00

Description

This vulnerability allows remote attackers to execute arbitrary code on vulnerable installations of Wecon PI Studio HMI Project Programmer. User interaction is required to exploit this vulnerability in that the target must visit a malicious page or open a malicious file. The specific flaw exists in the handling of PI Studio Project files. When parsing the TextContent field, the process does not properly validate the length of user-supplied data prior to copying it to a fixed-length stack-based buffer. An attacker can leverage this vulnerability to execute code under the context of the current process.